// BLEView.cpp : implementation of the CBLEView class
//

#include "stdafx.h"
#include "BLE.h"

#include "BLEDoc.h"
#include "BLEView.h"
#include "DMap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBLEView

IMPLEMENT_DYNCREATE(CBLEView, CScrollView)

BEGIN_MESSAGE_MAP(CBLEView, CScrollView)
	//{{AFX_MSG_MAP(CBLEView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_MAP_PROPERITES, OnMapProperites)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBLEView construction/destruction

CBLEView::CBLEView()
{
}

CBLEView::~CBLEView()
{
	if (mapbmp != NULL) { DeleteObject(mapbmp); mapbmp = NULL; }
}

BOOL CBLEView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
//	mapbmp = (HBITMAP)LoadImage(NULL, "ezdi.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	mapbmp = (HBITMAP)LoadImage(AfxGetApp()->m_hInstance, "IDB_EZDI", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
	

	SetScrollSizes( MM_TEXT, CSize(50*MAX_X, 50*MAX_Y));


	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBLEView drawing

void CBLEView::OnDraw(CDC* pDC)
{
	CBLEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	SetScrollSizes( MM_TEXT, CSize(50*GetDocument()->m_x, 50*GetDocument()->m_y));

	// TODO: add draw code for native data here
	CRect rect;
	pDC->GetClipBox(rect);

	int i,j;


	rect.top /= 50;
	rect.left /= 50;
	rect.right /= 50;
	rect.bottom /= 50;

	CBitmap *bmp = CBitmap::FromHandle(mapbmp);

	CDC cdc;

	cdc.CreateCompatibleDC(pDC);

	CBitmap *p_cdc = cdc.SelectObject(bmp);

	for(i = rect.left; i <= rect.right && i < pDoc->m_x; i++)
		for(j = rect.top; j <= rect.bottom && j < pDoc->m_y; j++) {
			pDC->BitBlt(i*50,j*50,50,50,&cdc,51*pDoc->m_map[i][j],0,SRCCOPY);
			if (pDoc->m_mapmrch[i][j] != -1)
				pDC->BitBlt(i*50+12, j*50+12, 25, 25, &cdc, 26*(pDoc->m_mapmrch[i][j]+1),51,SRCCOPY);
		}

	cdc.SelectObject(p_cdc);
}

/////////////////////////////////////////////////////////////////////////////
// CBLEView diagnostics

#ifdef _DEBUG
void CBLEView::AssertValid() const
{
	CView::AssertValid();
}

void CBLEView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBLEDoc* CBLEView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBLEDoc)));
	return (CBLEDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBLEView message handlers

void CBLEView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	SetCapture();
	if (GetCapture()) Insert(point);
	
	CScrollView::OnLButtonDown(nFlags, point);
}

void CBLEView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture();
	
	CScrollView::OnLButtonUp(nFlags, point);
}

void CBLEView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (GetCapture()) Insert(point);
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CBLEView::Insert(CPoint point)
{
	CRect rect;
	CRect softrect;
	rect.SetRect(point.x-50,point.y-50,point.x+50,point.y+50);

	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&point);
	point.x /= 50;
	point.y /= 50;


	CBLEDoc* pDoc = GetDocument();

	if (pDoc->m_map[point.x][point.y] == pal_selection)	return;
/*
	// aktualizace unda
	st_undo un;
	un.pos = point;
	un.hodnota = pDoc->data.mapa[point.x][point.y];
	un.type = UN_PLOCHA;
	pDoc->m_undo.AddHead(un);
	if(pDoc->m_undo.GetCount() > MAX_UNDO)
		pDoc->m_undo.RemoveTail();
*/
	pDoc->m_map[point.x][point.y] = pal_selection;

	pDoc->SetModifiedFlag(TRUE);

	InvalidateRect(&rect, FALSE);
}

void CBLEView::OnMapProperites() 
{
	CDMap dlg(GetDocument());
	if (dlg.DoModal() == IDOK) {
		SetScrollSizes( MM_TEXT, CSize(50*GetDocument()->m_x, 50*GetDocument()->m_y));
		Invalidate();
	}
}

void CBLEView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	InsertMrcha(point);

	CScrollView::OnRButtonDown(nFlags, point);
}

void CBLEView::InsertMrcha(CPoint point)
{
	CRect rect;
	CRect softrect;
	rect.SetRect(point.x-50,point.y-50,point.x+50,point.y+50);

	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&point);
	point.x /= 50;
	point.y /= 50;


	CBLEDoc* pDoc = GetDocument();

	if (pDoc->m_mapmrch[point.x][point.y] == pal_selection2)	return;

	pDoc->m_mapmrch[point.x][point.y] = pal_selection2;

	pDoc->SetModifiedFlag(TRUE);

	InvalidateRect(&rect, FALSE);
}
